/*

  INA219 Current and Power Monitoring Sensor

  Parts required:
  - Arduino Board
  - INA219 Current and Power Monitoring Sensor
  - External product to measure

  Library:
  - Adafruit_INA219

  Programming by : René Rasmussen
  Website : www.it-teknolog.dk
  Contact : renerasmussen@it-teknolog.dk
  Date : 3 Apr 2020
  Version : v1.0

  Modulet kan købes på www.arduinotech.dk

*/

#include <Adafruit_INA219.h>                          // include library Adafruit_INA219.h

Adafruit_INA219 sensor219;                            // create object sensor219 from library Adafruit_INA219

void setup(void)
{
  Serial.begin(9600);                                 // start Serial Monitor communication
  sensor219.begin();                                  // start sensor219
}

void loop(void)
{
  float busVoltage = 0;                               // set variable busVoltage as float
  float current = 0;                                  // set varaible current as float
  float power = 0;                                    // set variable power as float

  busVoltage = sensor219.getBusVoltage_V();           // read sensor219 busPowerVoltage and store in busVoltage
  current = sensor219.getCurrent_mA();                // read sensor219 getCurrent and store in current (reading in mA)
  power = busVoltage * (current / 1000);              // calculate the watt (mW)


  Serial.print("Bus Voltage:   ");                    // print text to Serial Monitor
  Serial.print(busVoltage);                           // print busVoltage
  Serial.println(" V");                               // print text to Serial Monitor

  Serial.print("Current:       ");                    // print text to Serial Monitor
  Serial.print(current);                              // print current
  Serial.println(" mA");

  Serial.print("Power:         ");                    // print text to Serial Monitor
  Serial.print(power);                                // print power
  Serial.println(" W");                               // print text to Serial Monitor

  Serial.println("");                                 // print empty line

  delay(2000);                                        // wait 2000ms
}
